unit Preview;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls;

type
  TfrmPreview = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    PreviewBox: TPaintBox;
    procedure CancelBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPreview: TfrmPreview;
  AlphaROM: array[1..8192] of byte;

implementation

{$R *.DFM}

procedure TfrmPreview.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmPreview.OKBtnClick(Sender: TObject);
var
  xchar, ychar: Integer;
  xsub, ysub: Integer;
  xpos, ypos: Integer;
  Address: Integer;
  Cell: Byte;
  Pix1, Pix0: Byte;
  Col1, Col0: TColor;
begin
  frmPreview.Caption := 'Preview [Busy]';
  { do 16 rows down }
  for ychar := 0 to 15 do
    begin
      { do 16 rows across }
      for xchar := 0 to 15 do
        begin
          { now paint each 8x8 pixel character }
          for ysub := 0 to 7 do
            begin
              { each of which has 8 rows }
              for xsub := 0 to 3 do
                begin
                  { each of which has 8 colums }
                  { each address has 2 pixels, 4 bits each }
                  Address := (xsub + (ysub * 4) + (xchar * 32) + (ychar * 512)) + 1;
                  Cell := AlphaROM[Address];
                  { where are we on the canvas? }
                  xpos := (xchar * 8) + (xsub * 2);
                  ypos := (ychar * 8) + ysub;
                  { get two pixels in this pass }
                  Pix0 := ((Cell and $07) shr 0);
                  Pix1 := ((Cell and $70) shr 4);
                  { put in some default initialization }
                  Col1 := $00000000;
                  Col0 := $00000000;
                  { now figure out the colors for pixel 0 }
                  if (Pix0 = 0) then Col0 := $00000000;
                  if (Pix0 = 1) then Col0 := $00ff0000;
                  if (Pix0 = 2) then Col0 := $0000ff00;
                  if (Pix0 = 3) then Col0 := $00ffff00;
                  if (Pix0 = 4) then Col0 := $000000ff;
                  if (Pix0 = 5) then Col0 := $00ff00ff;
                  if (Pix0 = 6) then Col0 := $0000ffff;
                  if (Pix0 = 7) then Col0 := $00ffffff;
                  { now figure out the colors for pixel 1 }
                  if (Pix1 = 0) then Col1 := $00000000;
                  if (Pix1 = 1) then Col1 := $00ff0000;
                  if (Pix1 = 2) then Col1 := $0000ff00;
                  if (Pix1 = 3) then Col1 := $00ffff00;
                  if (Pix1 = 4) then Col1 := $000000ff;
                  if (Pix1 = 5) then Col1 := $00ff00ff;
                  if (Pix1 = 6) then Col1 := $0000ffff;
                  if (Pix1 = 7) then Col1 := $00ffffff;
                  { add those pixels to the canvas }
                  PreviewBox.Canvas.Pixels[xpos+0,ypos] := Col0;
                  PreviewBox.Canvas.Pixels[xpos+1,ypos] := Col1;
                end;
            end;
        end;
    end;
  frmPreview.Caption := 'Preview [Done]';
  end;

end.