unit Text_ed;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, Spin, ExtCtrls, About, Preview;

type
  TfrmMain = class(TForm)
    MainMenu: TMainMenu;
    mbFile: TMenuItem;
    mbOpenFonts: TMenuItem;
    mbSaveFonts: TMenuItem;
    mbExit: TMenuItem;
    mbHelp: TMenuItem;
    mbAbout: TMenuItem;
    mbPreview: TMenuItem;
    mbCreate: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    CharacterNum: TSpinEdit;
    AcceptBtn: TButton;
    EditGrid: TGroupBox;
    Pal0: TImage;
    Pal1: TImage;
    Pal2: TImage;
    Pal3: TImage;
    Pal4: TImage;
    Pal5: TImage;
    Pal6: TImage;
    Pal7: TImage;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    Image10: TImage;
    Image11: TImage;
    Image12: TImage;
    Image13: TImage;
    Image14: TImage;
    Image15: TImage;
    Image16: TImage;
    Image17: TImage;
    Image18: TImage;
    Image19: TImage;
    Image20: TImage;
    Image21: TImage;
    Image22: TImage;
    Image23: TImage;
    Image24: TImage;
    Image25: TImage;
    Image26: TImage;
    Image27: TImage;
    Image28: TImage;
    Image29: TImage;
    Image30: TImage;
    Image31: TImage;
    Image32: TImage;
    Image33: TImage;
    Image34: TImage;
    Image35: TImage;
    Image36: TImage;
    Image37: TImage;
    Image38: TImage;
    Image39: TImage;
    Image40: TImage;
    Image41: TImage;
    Image42: TImage;
    Image43: TImage;
    Image44: TImage;
    Image45: TImage;
    Image46: TImage;
    Image47: TImage;
    Image48: TImage;
    Image49: TImage;
    Image50: TImage;
    Image51: TImage;
    Image52: TImage;
    Image53: TImage;
    Image54: TImage;
    Image55: TImage;
    Image56: TImage;
    Image57: TImage;
    Image58: TImage;
    Image59: TImage;
    Image60: TImage;
    Image61: TImage;
    Image62: TImage;
    Image63: TImage;
    Image64: TImage;
    Box0: TShape;
    Box1: TShape;
    Box2: TShape;
    Box3: TShape;
    Box4: TShape;
    Box5: TShape;
    Box6: TShape;
    Box7: TShape;
    ExportColorROM: TMenuItem;
    ExportMonoROM: TMenuItem;
    SaveROMDialog: TSaveDialog;
    ExportStructuralMonoROM: TMenuItem;
    ExportStructuralColorROM: TMenuItem;
    procedure Init_Form(Sender: TObject);
    procedure Exit_App(Sender: TObject);
    procedure mbOpenFontsClick(Sender: TObject);
    procedure ImageDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ImageDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure mbSaveFontsClick(Sender: TObject);
    procedure mbAboutClick(Sender: TObject);
    procedure CharacterNumChange(Sender: TObject);
    procedure mbCreateClick(Sender: TObject);
    procedure AcceptBtnClick(Sender: TObject);
    procedure ExportColorROMClick(Sender: TObject);
    procedure ExportMonoROMClick(Sender: TObject);
    procedure ExportStructMonoROMClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  CurrentChar: array[1..64] of byte;
  CurrentNum: Integer;

implementation

{$R *.DFM}

function IntHex (Number: Integer) : Char;
begin
  case Number of
  0 : Result := '0';
  1 : Result := '1';
  2 : Result := '2';
  3 : Result := '3';
  4 : Result := '4';
  5 : Result := '5';
  6 : Result := '6';
  7 : Result := '7';
  8 : Result := '8';
  9 : Result := '9';
  10 : Result := 'A';
  11 : Result := 'B';
  12 : Result := 'C';
  13 : Result := 'D';
  14 : Result := 'E';
  15 : Result := 'F';
  else Result := 'X';
  end
end;

procedure TfrmMain.Init_Form(Sender: TObject);
var
   I: Integer;
begin
  for I:= 1 to 8192 do
    begin
      AlphaROM[I] := 0;
    end;
  for I:= 1 to 64 do
    begin
      CurrentChar[I] := 0;
    end;
  CurrentNum := 0;
end;

procedure TfrmMain.Exit_App(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.mbOpenFontsClick(Sender: TObject);
var
  InFile: File of Byte;
  I, Address: Integer;
  PCI, ECI: Integer;
  Cell, Pix1, Pix0: Byte;
  size: Longint;
begin
  If OpenDialog.Execute then
    begin
      AssignFile(InFile, OpenDialog.FileName);
      EditGrid.Caption := OpenDialog.Filename;
      Reset(InFile);
      size := FileSize(InFile);
      if (size > 8192) then size := 8192;

      for I:= 1 to size do
        begin
        Read(InFile, Cell);
        AlphaROM[I] := Cell;
        end;

      CloseFile(InFile);

      { find out where the palette and edit component indices begin }
      PCI := (Pal0.ComponentIndex);
      ECI := (Image1.ComponentIndex);
      Address := (CharacterNum.Value * 32) + 1;
      for I := 0 to 31 do
        begin
          Cell := AlphaROM[Address + I];
          Pix1 := ((Cell and $70) shr 4);
          Pix0 := ((Cell and $07) shr 0);

          (Components[ECI + (2*I) + 0] as TImage).Picture := (Components[PCI + Pix0] as TImage).Picture;
          case (Pix0) of
            0: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 0';
            1: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 1';
            2: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 2';
            3: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 3';
            4: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 4';
            5: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 5';
            6: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 6';
            7: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 7';
            end;

          (Components[ECI + (2*I) + 1] as TImage).Picture := (Components[PCI + Pix1] as TImage).Picture;
          case (Pix1) of
            0: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 0';
            1: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 1';
            2: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 2';
            3: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 3';
            4: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 4';
            5: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 5';
            6: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 6';
            7: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 7';
          end;
        end;
    end;
end;

procedure TfrmMain.ImageDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := True;
end;

procedure TfrmMain.ImageDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  (Sender as TImage).Picture := (Source as TImage).Picture;
  (Sender as TImage).Hint := (Source as TImage).Hint;
end;

procedure TfrmMain.mbSaveFontsClick(Sender: TObject);
var
  OutFile: File of Byte;
  I: Integer;
  Cell: Byte;
begin
  If SaveDialog.Execute then
    begin
      AssignFile(OutFile, SaveDialog.FileName);
      EditGrid.Caption := SaveDialog.Filename;
      Rewrite(OutFile);

      for I:= 1 to 8192 do
        begin
        Cell := AlphaROM[I];
        Write(OutFile, Cell);
        end;
      CloseFile(OutFile);
    end;
end;

procedure TfrmMain.mbAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TfrmMain.CharacterNumChange(Sender: TObject);
var
  I, Address: Integer;
  PCI, ECI: Integer;
  Cell, Pix1, Pix0: Byte;
begin
  { find out where the palette and edit component indices begin }
  PCI := (Pal0.ComponentIndex);
  ECI := (Image1.ComponentIndex);
  Address := (CharacterNum.Value * 32) + 1;
  for I := 0 to 31 do
    begin
      Cell := AlphaROM[Address + I];
      Pix1 := ((Cell and $70) shr 4);
      Pix0 := ((Cell and $07) shr 0);

      (Components[ECI + (2*I) + 0] as TImage).Picture := (Components[PCI + Pix0] as TImage).Picture;
      case (Pix0) of
        0: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 0';
        1: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 1';
        2: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 2';
        3: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 3';
        4: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 4';
        5: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 5';
        6: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 6';
        7: (Components[ECI + (2*I) + 0] as TImage).Hint := 'Color 7';
        end;

      (Components[ECI + (2*I) + 1] as TImage).Picture := (Components[PCI + Pix1] as TImage).Picture;
      case (Pix1) of
        0: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 0';
        1: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 1';
        2: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 2';
        3: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 3';
        4: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 4';
        5: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 5';
        6: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 6';
        7: (Components[ECI + (2*I) + 1] as TImage).Hint := 'Color 7';
        end;
  end;
end;

procedure TfrmMain.mbCreateClick(Sender: TObject);
begin
  frmPreview.Show
end;

procedure TfrmMain.AcceptBtnClick(Sender: TObject);
var
  I, Address: Integer;
  ECI: Integer;
  Cell: Byte;
begin
  { find out where the edit component index begins }
  ECI := (Image1.ComponentIndex);
  { write the contents of the edit area into the array }
  Address := (CharacterNum.Value * 32) + 1;
  for I := 0 to 31 do
    begin
      Cell := $00;
      { now add in what's there }
      if ((Components[ECI + (2*I) + 0] as TImage).Hint = 'Color 0') then Cell := Cell or $00;
      if ((Components[ECI + (2*I) + 0] as TImage).Hint = 'Color 1') then Cell := Cell or $01;
      if ((Components[ECI + (2*I) + 0] as TImage).Hint = 'Color 2') then Cell := Cell or $02;
      if ((Components[ECI + (2*I) + 0] as TImage).Hint = 'Color 3') then Cell := Cell or $03;
      if ((Components[ECI + (2*I) + 0] as TImage).Hint = 'Color 4') then Cell := Cell or $04;
      if ((Components[ECI + (2*I) + 0] as TImage).Hint = 'Color 5') then Cell := Cell or $05;
      if ((Components[ECI + (2*I) + 0] as TImage).Hint = 'Color 6') then Cell := Cell or $06;
      if ((Components[ECI + (2*I) + 0] as TImage).Hint = 'Color 7') then Cell := Cell or $07;
      if ((Components[ECI + (2*I) + 1] as TImage).Hint = 'Color 0') then Cell := Cell or $00;
      if ((Components[ECI + (2*I) + 1] as TImage).Hint = 'Color 1') then Cell := Cell or $10;
      if ((Components[ECI + (2*I) + 1] as TImage).Hint = 'Color 2') then Cell := Cell or $20;
      if ((Components[ECI + (2*I) + 1] as TImage).Hint = 'Color 3') then Cell := Cell or $30;
      if ((Components[ECI + (2*I) + 1] as TImage).Hint = 'Color 4') then Cell := Cell or $40;
      if ((Components[ECI + (2*I) + 1] as TImage).Hint = 'Color 5') then Cell := Cell or $50;
      if ((Components[ECI + (2*I) + 1] as TImage).Hint = 'Color 6') then Cell := Cell or $60;
      if ((Components[ECI + (2*I) + 1] as TImage).Hint = 'Color 7') then Cell := Cell or $70;
      { store it away }
      AlphaROM[Address + I] := Cell;
    end;
end;

procedure TfrmMain.ExportColorROMClick(Sender: TObject);
var
  ColorFile: TextFile;
  I, APix0, APix1: Integer;
  Cell, Pix0, Pix1: Byte;
begin
  If SaveROMDialog.Execute then
    begin
      AssignFile(ColorFile, SaveROMDialog.FileName);
      Rewrite(ColorFile);
      Writeln(ColorFile, '/***********************************************************************\');
      Writeln(ColorFile, ' ');
      Write  (ColorFile, '  File: ');
      Writeln(ColorFile, SaveROMDialog.FileName);
      Writeln(ColorFile, ' ');
      Writeln(ColorFile, '  This is a behavioral Color Font BlockROM generated by the fed program.');
      Writeln(ColorFile, '  The address is split into three inputs.  The most significant bits');
      Writeln(ColorFile, '  select the character to be displayed.  The least significant bits');
      Writeln(ColorFile, '  select which pixel in the character is addressed.  Scanning is done');
      Writeln(ColorFile, '  on v_addr from top (0) to bottom (7) and on h_addr from left (0) to');
      Writeln(ColorFile, '  right (7).  The three bit output is rgb, in that order.');
      Writeln(ColorFile, ' ');
      Writeln(ColorFile, '  Copyright (c) 2005 Eric Crabill.  All rights reserved.  This design');
      Writeln(ColorFile, '  is provided solely for non-commercial, educational purposes.  Eric');
      Writeln(ColorFile, '  Crabill makes no warranties, and accepts no liability, with respect');
      Writeln(ColorFile, '  to this design or its use, and any use thereof is solely at the risk');
      Writeln(ColorFile, '  of the user.  This copyright notice must be retained as part of this');
      Writeln(ColorFile, '  text at all times.');
      Writeln(ColorFile, ' ');
      Writeln(ColorFile, '***********************************************************************/');
      Writeln(ColorFile, ' ');
      Writeln(ColorFile, '`timescale 1 ns / 1 ps');
      Writeln(ColorFile, ' ');
      Writeln(ColorFile, 'module fontrom_3bpp (c_addr, v_addr, h_addr, rgb, clk);');
      Writeln(ColorFile, ' ');
      Writeln(ColorFile, '  input   [7:0] c_addr;');
      Writeln(ColorFile, '  input   [2:0] v_addr;');
      Writeln(ColorFile, '  input   [2:0] h_addr;');
      Writeln(ColorFile, '  output  [2:0] rgb;');
      Writeln(ColorFile, '  input         clk;');
      Writeln(ColorFile, ' ');
      Writeln(ColorFile, '  //******************************************************************//');
      Writeln(ColorFile, '  // Behavioral BlockROM description should synthesize properly...    //');
      Writeln(ColorFile, '  //******************************************************************//');
      Writeln(ColorFile, ' ');
      Writeln(ColorFile, '  wire   [13:0] addr;');
      Writeln(ColorFile, '  reg     [2:0] rgb;');
      Writeln(ColorFile, ' ');
      Writeln(ColorFile, '  assign addr = {c_addr, v_addr, h_addr};');
      Writeln(ColorFile, ' ');
      Writeln(ColorFile, '  always @(posedge clk)');
      Writeln(ColorFile, '  begin');
      Writeln(ColorFile, '    case (addr)');
      for I:= 1 to 8192 do
        begin
        Cell := AlphaROM[I];
        APix0 := (2 * (I - 1)) + 0;
        APix1 := (2 * (I - 1)) + 1;
        Pix1 := ((Cell and $70) shr 4);
        Pix0 := ((Cell and $07) shr 0);
        Write  (ColorFile, '      ');
        Write  (ColorFile, APix0);
        Write  (ColorFile, ': rgb = 3''d');
        Write  (ColorFile, Pix0);
        Writeln(ColorFile, ';');
        Write  (ColorFile, '      ');
        Write  (ColorFile, APix1);
        Write  (ColorFile, ': rgb = 3''d');
        Write  (ColorFile, Pix1);
        Writeln(ColorFile, ';');
        end;
      Writeln(ColorFile, '      default: rgb = 3''d0;');
      Writeln(ColorFile, '    endcase');
      Writeln(ColorFile, '  end');
      Writeln(ColorFile, ' ');
      Writeln(ColorFile, '  //******************************************************************//');
      Writeln(ColorFile, '  //                                                                  //');
      Writeln(ColorFile, '  //******************************************************************//');
      Writeln(ColorFile, ' ');
      Writeln(ColorFile, 'endmodule');
      CloseFile(ColorFile);
    end;
end;

procedure TfrmMain.ExportMonoROMClick(Sender: TObject);
var
  MonoFile: TextFile;
  I, APix0, APix1: Integer;
  Cell, Pix0, Pix1: Byte;
begin
  If SaveROMDialog.Execute then
    begin
      AssignFile(MonoFile, SaveROMDialog.FileName);
      Rewrite(MonoFile);
      Writeln(MonoFile, '/***********************************************************************\');
      Writeln(MonoFile, ' ');
      Write  (MonoFile, '  File: ');
      Writeln(MonoFile, SaveROMDialog.FileName);
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  This is a behavioral Mono Font BlockROM generated by the fed program.');
      Writeln(MonoFile, '  The address is split into three inputs.  The most significant bits');
      Writeln(MonoFile, '  select the character to be displayed.  The least significant bits');
      Writeln(MonoFile, '  select which pixel in the character is addressed.  Scanning is done');
      Writeln(MonoFile, '  on v_addr from top (0) to bottom (7) and on h_addr from left (0) to');
      Writeln(MonoFile, '  right (7).  The one bit output is pix.');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  Copyright (c) 2005 Eric Crabill.  All rights reserved.  This design');
      Writeln(MonoFile, '  is provided solely for non-commercial, educational purposes.  Eric');
      Writeln(MonoFile, '  Crabill makes no warranties, and accepts no liability, with respect');
      Writeln(MonoFile, '  to this design or its use, and any use thereof is solely at the risk');
      Writeln(MonoFile, '  of the user.  This copyright notice must be retained as part of this');
      Writeln(MonoFile, '  text at all times.');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '***********************************************************************/');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '`timescale 1 ns / 1 ps');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, 'module fontrom_1bpp (c_addr, v_addr, h_addr, pix, clk);');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  input   [7:0] c_addr;');
      Writeln(MonoFile, '  input   [2:0] v_addr;');
      Writeln(MonoFile, '  input   [2:0] h_addr;');
      Writeln(MonoFile, '  output        pix;');
      Writeln(MonoFile, '  input         clk;');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  //******************************************************************//');
      Writeln(MonoFile, '  // Behavioral BlockROM description should synthesize properly...    //');
      Writeln(MonoFile, '  //******************************************************************//');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  wire   [13:0] addr;');
      Writeln(MonoFile, '  reg           pix;');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  assign addr = {c_addr, v_addr, h_addr};');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  always @(posedge clk)');
      Writeln(MonoFile, '  begin');
      Writeln(MonoFile, '    case (addr)');
      for I:= 1 to 8192 do
        begin
        Cell := AlphaROM[I];
        APix0 := (2 * (I - 1)) + 0;
        APix1 := (2 * (I - 1)) + 1;
        Pix1 := ((Cell and $70) shr 4);
        if (Pix1 <> 0) then Pix1 := 1;
        Pix0 := ((Cell and $07) shr 0);
        if (Pix0 <> 0) then Pix0 := 1;
        Write  (MonoFile, '      ');
        Write  (MonoFile, APix0);
        Write  (MonoFile, ': pix = 1''d');
        Write  (MonoFile, Pix0);
        Writeln(MonoFile, ';');
        Write  (MonoFile, '      ');
        Write  (MonoFile, APix1);
        Write  (MonoFile, ': pix = 1''d');
        Write  (MonoFile, Pix1);
        Writeln(MonoFile, ';');
        end;
      Writeln(MonoFile, '      default: pix = 1''d0;');
      Writeln(MonoFile, '    endcase');
      Writeln(MonoFile, '  end');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  //******************************************************************//');
      Writeln(MonoFile, '  //                                                                  //');
      Writeln(MonoFile, '  //******************************************************************//');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, 'endmodule');
      CloseFile(MonoFile);
    end;
end;

procedure TfrmMain.ExportStructMonoROMClick(Sender: TObject);
var
  MonoFile: TextFile;
  PackedBits: array[1..2048] of byte;
  I, init, step: Integer;
  Cell0, Cell1, Cell2, Cell3: Byte;
  PackedPix, Pix0, Pix1, Pix2, Pix3, Pix4, Pix5, Pix6, Pix7: Byte;
begin
  If SaveROMDialog.Execute then
    begin
      AssignFile(MonoFile, SaveROMDialog.FileName);
      Rewrite(MonoFile);
      Writeln(MonoFile, '/***********************************************************************\');
      Writeln(MonoFile, ' ');
      Write  (MonoFile, '  File: ');
      Writeln(MonoFile, SaveROMDialog.FileName);
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  This is a structural Mono Font BlockROM generated by the fed program.');
      Writeln(MonoFile, '  The address is split into three inputs.  The most significant bits');
      Writeln(MonoFile, '  select the character to be displayed.  The least significant bits');
      Writeln(MonoFile, '  select which pixel in the character is addressed.  Scanning is done');
      Writeln(MonoFile, '  on v_addr from top (0) to bottom (7) and on h_addr from left (0) to');
      Writeln(MonoFile, '  right (7).  The one bit output is pix.');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  Copyright (c) 2005 Eric Crabill.  All rights reserved.  This design');
      Writeln(MonoFile, '  is provided solely for non-commercial, educational purposes.  Eric');
      Writeln(MonoFile, '  Crabill makes no warranties, and accepts no liability, with respect');
      Writeln(MonoFile, '  to this design or its use, and any use thereof is solely at the risk');
      Writeln(MonoFile, '  of the user.  This copyright notice must be retained as part of this');
      Writeln(MonoFile, '  text at all times.');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '***********************************************************************/');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '`timescale 1 ns / 1 ps');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, 'module fontrom_1bpp (c_addr, v_addr, h_addr, pix, clk);');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  input   [7:0] c_addr;');
      Writeln(MonoFile, '  input   [2:0] v_addr;');
      Writeln(MonoFile, '  input   [2:0] h_addr;');
      Writeln(MonoFile, '  output        pix;');
      Writeln(MonoFile, '  input         clk;');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  //******************************************************************//');
      Writeln(MonoFile, '  // Structural BlockROM description should synthesize properly...    //');
      Writeln(MonoFile, '  //******************************************************************//');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  wire   [13:0] addr;');
      Writeln(MonoFile, '  wire          pix;');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  assign addr = {c_addr, v_addr, h_addr};');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  RAMB16_S1 ROM0 (');
      Writeln(MonoFile, '                 .DO(pix),');
      Writeln(MonoFile, '                 .ADDR(addr),');
      Writeln(MonoFile, '                 .DI(1''b0),');
      Writeln(MonoFile, '                 .EN(1''b1),');
      Writeln(MonoFile, '                 .WE(1''b0),');
      Writeln(MonoFile, '                 .SSR(1''b0),');
      Writeln(MonoFile, '                 .CLK(clk)');
      Writeln(MonoFile, '                 );');
      Writeln(MonoFile, ' ');
      for I:= 1 to 2048 do
        begin
        Cell0 := AlphaROM[(4 * (I - 1)) + 1];
        Cell1 := AlphaROM[(4 * (I - 1)) + 2];
        Cell2 := AlphaROM[(4 * (I - 1)) + 3];
        Cell3 := AlphaROM[(4 * (I - 1)) + 4];
        Pix0 := ((Cell0 and $07) shr 0);
        Pix1 := ((Cell0 and $70) shr 4);
        Pix2 := ((Cell1 and $07) shr 0);
        Pix3 := ((Cell1 and $70) shr 4);
        Pix4 := ((Cell2 and $07) shr 0);
        Pix5 := ((Cell2 and $70) shr 4);
        Pix6 := ((Cell3 and $07) shr 0);
        Pix7 := ((Cell3 and $70) shr 4);
        PackedPix := $00;
        if (Pix0 <> 0) then PackedPix := PackedPix or $01;
        if (Pix1 <> 0) then PackedPix := PackedPix or $02;
        if (Pix2 <> 0) then PackedPix := PackedPix or $04;
        if (Pix3 <> 0) then PackedPix := PackedPix or $08;
        if (Pix4 <> 0) then PackedPix := PackedPix or $10;
        if (Pix5 <> 0) then PackedPix := PackedPix or $20;
        if (Pix6 <> 0) then PackedPix := PackedPix or $40;
        if (Pix7 <> 0) then PackedPix := PackedPix or $80;
        PackedBits[I] := PackedPix;
        end;
      for init:= 0 to 63 do
        begin
        Write  (MonoFile, '  // synthesis attribute INIT_');
        Write  (MonoFile, IntHex((init and $f0) shr 4));
        Write  (MonoFile, IntHex((init and $0f) shr 0));
        Write  (MonoFile, ' of ROM0 is "');
        for step:= 0 to 31 do
          begin
          PackedPix := PackedBits[((init * 32) + 32 - step)];
          Write  (MonoFile, IntHex((PackedPix and $f0) shr 4));
          Write  (MonoFile, IntHex((PackedPix and $0f) shr 0));
          end;
        Writeln(MonoFile, '"');
        end;
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  // synthesis translate_off');
      for init:= 0 to 63 do
        begin
        Write  (MonoFile, '  defparam ROM0.INIT_');
        Write  (MonoFile, IntHex((init and $f0) shr 4));
        Write  (MonoFile, IntHex((init and $0f) shr 0));
        Write  (MonoFile, ' = 256''h');
        for step:= 0 to 31 do
          begin
          PackedPix := PackedBits[((init * 32) + 32 - step)];
          Write  (MonoFile, IntHex((PackedPix and $f0) shr 4));
          Write  (MonoFile, IntHex((PackedPix and $0f) shr 0));
          end;
        Writeln(MonoFile, ';');
        end;
      Writeln(MonoFile, '  // synthesis translate_on');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, '  //******************************************************************//');
      Writeln(MonoFile, '  //                                                                  //');
      Writeln(MonoFile, '  //******************************************************************//');
      Writeln(MonoFile, ' ');
      Writeln(MonoFile, 'endmodule');
      CloseFile(MonoFile);
    end;
end;

end.
